import { App } from 'vue';
import { FusionAuth, FusionAuthConfig, UserInfo } from './types.ts';
type FusionAuthInstantiated = {
    instance: FusionAuth<UserInfo | any>;
};
/**
 * Installation method for the FusionAuthVuePlugin.
 *
 * @category Plugin
 * @param {App} app - The Vue app instance.
 * @param {FusionAuthConfig | FusionAuthInstantiated} options - The configuration options for the plugin or an object containing a FusionAuth instance.
 * @throws {Error} Will throw an error if the required options are missing.
 */
declare const FusionAuthVuePlugin: {
    install(app: App, options: FusionAuthConfig | FusionAuthInstantiated): void;
};
export default FusionAuthVuePlugin;
