import { inject as E, defineComponent as c, openBlock as p, createElementBlock as _, renderSlot as l, createTextVNode as m, unref as w, computed as x, createCommentVNode as I, ref as f } from "vue";
const P = Symbol("fusionAuth"), h = () => {
  const r = E(P);
  if (!r)
    throw new Error(
      "No FusionAuth instance found. Did you forget to call Vue.use(FusionAuthVuePlugin)?"
    );
  return r;
}, T = /* @__PURE__ */ c({
  __name: "FusionAuthLoginButton",
  props: {
    state: {}
  },
  setup(r) {
    const t = h(), e = r;
    function o() {
      t.login(e.state);
    }
    return (n, s) => (p(), _("button", {
      class: "login-button",
      onClick: s[0] || (s[0] = (u) => o())
    }, [
      l(n.$slots, "default", {}, () => [
        m("Login")
      ], !0)
    ]));
  }
});
const R = (r, t) => {
  const e = r.__vccOpts || r;
  for (const [o, n] of t)
    e[o] = n;
  return e;
}, b = /* @__PURE__ */ R(T, [["__scopeId", "data-v-e1ac1678"]]), F = /* @__PURE__ */ c({
  __name: "FusionAuthLogoutButton",
  setup(r) {
    const t = h();
    function e() {
      t.logout();
    }
    return (o, n) => (p(), _("button", {
      class: "logout-button",
      onClick: n[0] || (n[0] = (s) => e())
    }, [
      l(o.$slots, "default", {}, () => [
        m("Logout")
      ], !0)
    ]));
  }
});
const C = /* @__PURE__ */ R(F, [["__scopeId", "data-v-fb8f3354"]]), S = /* @__PURE__ */ c({
  __name: "FusionAuthRegisterButton",
  props: {
    state: {}
  },
  setup(r) {
    const t = h(), e = r;
    function o() {
      t.register(e.state);
    }
    return (n, s) => (p(), _("button", {
      class: "register-button",
      onClick: s[0] || (s[0] = (u) => o())
    }, [
      l(n.$slots, "default", {}, () => [
        m("Register")
      ], !0)
    ]));
  }
});
const $ = /* @__PURE__ */ R(S, [["__scopeId", "data-v-6adc2447"]]), B = /* @__PURE__ */ c({
  __name: "FusionAuthAccountButton",
  setup(r) {
    const { manageAccount: t } = h();
    return (e, o) => (p(), _("button", {
      class: "fusionauth-button",
      onClick: o[0] || (o[0] = (n) => w(t)())
    }, [
      l(e.$slots, "default", {}, () => [
        m("Manage Account")
      ], !0)
    ]));
  }
});
const H = /* @__PURE__ */ R(B, [["__scopeId", "data-v-e13f9c86"]]), V = /* @__PURE__ */ c({
  __name: "RequireAuth",
  props: {
    withRole: {}
  },
  setup(r) {
    const t = r, { isLoggedIn: e, userInfo: o } = h(), n = x(() => {
      var d;
      if (!e.value || o.value === null)
        return !1;
      if (!t.withRole)
        return !0;
      const s = Array.isArray(t.withRole) ? t.withRole : [t.withRole], u = ((d = o.value) == null ? void 0 : d.roles) ?? [], a = e.value === !0, A = u.some((U) => s.includes(U));
      return a && A;
    });
    return (s, u) => n.value ? l(s.$slots, "default", { key: 0 }) : I("", !0);
  }
}), q = /* @__PURE__ */ c({
  __name: "RequireAnonymous",
  setup(r) {
    const { isLoggedIn: t } = h();
    return (e, o) => w(t) ? I("", !0) : l(e.$slots, "default", { key: 0 });
  }
}), D = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  FusionAuthAccountButton: H,
  FusionAuthLoginButton: b,
  FusionAuthLogoutButton: C,
  FusionAuthRegisterButton: $,
  RequireAnonymous: q,
  RequireAuth: V
}, Symbol.toStringTag, { value: "Module" }));
var j = Object.defineProperty, O = (r, t, e) => t in r ? j(r, t, { enumerable: !0, configurable: !0, writable: !0, value: e }) : r[t] = e, i = (r, t, e) => O(r, typeof t != "symbol" ? t + "" : t, e);
class M {
  constructor(t) {
    i(this, "serverUrl"), i(this, "clientId"), i(this, "redirectUri"), i(this, "scope"), i(this, "mePath"), i(this, "loginPath"), i(this, "registerPath"), i(this, "logoutPath"), i(this, "tokenRefreshPath"), i(this, "postLogoutRedirectUri"), this.serverUrl = t.serverUrl, this.clientId = t.clientId, this.redirectUri = t.redirectUri, this.scope = t.scope, this.postLogoutRedirectUri = t.postLogoutRedirectUri, this.mePath = t.mePath ?? "/app/me/", this.loginPath = t.loginPath ?? "/app/login/", this.registerPath = t.registerPath ?? "/app/register/", this.logoutPath = t.logoutPath ?? "/app/logout/", this.tokenRefreshPath = t.tokenRefreshPath ?? "/app/refresh/";
  }
  getMeUrl() {
    return this.generateUrl(this.mePath);
  }
  getLoginUrl(t) {
    return this.generateUrl(this.loginPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: t
    });
  }
  getRegisterUrl(t) {
    return this.generateUrl(this.registerPath, {
      client_id: this.clientId,
      redirect_uri: this.redirectUri,
      scope: this.scope,
      state: t
    });
  }
  getLogoutUrl() {
    return this.generateUrl(this.logoutPath, {
      client_id: this.clientId,
      post_logout_redirect_uri: this.postLogoutRedirectUri || this.redirectUri
    });
  }
  getTokenRefreshUrl() {
    return this.generateUrl(this.tokenRefreshPath, {
      client_id: this.clientId
    });
  }
  getAccountManagementUrl() {
    return this.generateUrl("/account/", {
      client_id: this.clientId
    });
  }
  generateUrl(t, e) {
    const o = new URL(this.serverUrl);
    if (o.pathname = t, e) {
      const n = this.generateURLSearchParams(e);
      o.search = n.toString();
    }
    return o;
  }
  generateURLSearchParams(t) {
    const e = new URLSearchParams();
    return Object.entries(t).forEach(([o, n]) => {
      n && e.append(o, n);
    }), e;
  }
}
class N {
  constructor() {
    i(this, "REDIRECT_VALUE", "fa-sdk-redirect-value");
  }
  get storage() {
    try {
      return localStorage;
    } catch {
      return {
        /* eslint-disable */
        setItem(t, e) {
        },
        getItem(t) {
        },
        removeItem(t) {
        }
        /* eslint-enable */
      };
    }
  }
  handlePreRedirect(t) {
    const e = `${this.generateRandomString()}:${t ?? ""}`;
    this.storage.setItem(this.REDIRECT_VALUE, e);
  }
  handlePostRedirect(t) {
    const e = this.stateValue ?? void 0;
    t == null || t(e), this.storage.removeItem(this.REDIRECT_VALUE);
  }
  get didRedirect() {
    return !!this.storage.getItem(this.REDIRECT_VALUE);
  }
  get stateValue() {
    const t = this.storage.getItem(this.REDIRECT_VALUE);
    if (!t)
      return null;
    const [, ...e] = t.split(":");
    return e.join(":");
  }
  generateRandomString() {
    const t = new Uint32Array(28);
    return window.crypto.getRandomValues(t), Array.from(
      t,
      (e) => ("0" + e.toString(16)).substring(-2)
    ).join("");
  }
}
function z(r = "app.at_exp", t) {
  if (t)
    return v(t.at_exp(r));
  let e;
  try {
    e = document.cookie;
  } catch {
    return console.error(
      "Error accessing cookies in fusionauth. If you are using SSR you must configure the SDK with a cookie adapter"
    ), -1;
  }
  const o = e.split("; ").map((s) => s.split("=")).find(([s]) => s === r), n = o == null ? void 0 : o[1];
  return v(n);
}
function v(r) {
  return r ? Number(r) * 1e3 : -1;
}
class K {
  constructor(t) {
    i(this, "config"), i(this, "urlHelper"), i(this, "redirectHelper", new N()), i(this, "tokenExpirationTimeout"), this.config = t, this.urlHelper = new M({
      serverUrl: t.serverUrl,
      clientId: t.clientId,
      redirectUri: t.redirectUri,
      scope: t.scope,
      mePath: t.mePath,
      loginPath: t.loginPath,
      registerPath: t.registerPath,
      logoutPath: t.logoutPath,
      tokenRefreshPath: t.tokenRefreshPath,
      postLogoutRedirectUri: t.postLogoutRedirectUri
    }), this.scheduleTokenExpiration();
  }
  startLogin(t) {
    this.redirectHelper.handlePreRedirect(t), window.location.assign(this.urlHelper.getLoginUrl(t));
  }
  startRegister(t) {
    this.redirectHelper.handlePreRedirect(t), window.location.assign(this.urlHelper.getRegisterUrl(t));
  }
  startLogout() {
    window.location.assign(this.urlHelper.getLogoutUrl());
  }
  manageAccount() {
    window.location.assign(this.urlHelper.getAccountManagementUrl());
  }
  async fetchUserInfo() {
    const t = await fetch(this.urlHelper.getMeUrl(), {
      credentials: "include"
    });
    if (!t.ok)
      throw new Error(
        `Unable to fetch userInfo in fusionauth. Request failed with status code ${t == null ? void 0 : t.status}`
      );
    return await t.json();
  }
  async refreshToken() {
    const t = await fetch(this.urlHelper.getTokenRefreshUrl(), {
      method: "POST",
      credentials: "include",
      headers: {
        "Content-Type": "text/plain"
      }
    });
    if (!(t.status >= 200 && t.status < 300)) {
      const e = {
        status: t.status,
        details: await (t == null ? void 0 : t.text()) || "Failed to refresh fusionauth access token"
      };
      throw new Error(JSON.stringify(e));
    }
    return this.scheduleTokenExpiration(), t;
  }
  initAutoRefresh() {
    if (!this.isLoggedIn)
      return;
    const t = (this.config.autoRefreshSecondsBeforeExpiry ?? 10) * 1e3, e = (/* @__PURE__ */ new Date()).getTime(), o = this.at_exp - t, n = Math.max(o - e, 0);
    return setTimeout(async () => {
      var s, u;
      try {
        await this.refreshToken(), this.initAutoRefresh();
      } catch (a) {
        (u = (s = this.config).onAutoRefreshFailure) == null || u.call(s, a);
      }
    }, n);
  }
  handlePostRedirect(t) {
    this.isLoggedIn && this.redirectHelper.didRedirect && this.redirectHelper.handlePostRedirect(t);
  }
  get isLoggedIn() {
    return this.at_exp > (/* @__PURE__ */ new Date()).getTime();
  }
  /** The moment of access token expiration in milliseconds since epoch. */
  get at_exp() {
    return z(
      this.config.accessTokenExpireCookieName,
      this.config.cookieAdapter
    );
  }
  /**
   * Schedules `onTokenExpiration` at moment of access token expiration.
   * SDKCore is not necessarily reactive like React, Angular, and Vue.
   * so `onTokenExpiration` is for reactive frameworks to hook in and perform actions as on token expiration.
   */
  scheduleTokenExpiration() {
    clearTimeout(this.tokenExpirationTimeout);
    const t = (/* @__PURE__ */ new Date()).getTime(), e = this.at_exp - t;
    e > 0 && (this.tokenExpirationTimeout = setTimeout(
      this.config.onTokenExpiration,
      e
    ));
  }
}
class G {
  constructor(t) {
    this.useCookie = t, this.useCookie = t;
  }
  at_exp(t = "app.at_exp") {
    return this.useCookie(t).value ?? void 0;
  }
}
const J = (r) => {
  let t;
  r.nuxtUseCookie && (t = new G(r.nuxtUseCookie));
  const e = new K({
    ...r,
    cookieAdapter: t,
    onTokenExpiration: () => {
      o.value = !1;
    }
  }), o = f(e.isLoggedIn), n = f(null), s = f(!1), u = f(null);
  async function a() {
    s.value = !0, u.value = null;
    try {
      return n.value = await e.fetchUserInfo(), n.value;
    } catch (g) {
      u.value = g;
    } finally {
      s.value = !1;
    }
  }
  async function A() {
    return await e.refreshToken();
  }
  function d() {
    return e.initAutoRefresh();
  }
  function U(g) {
    e.startLogin(g);
  }
  function k(g) {
    e.startRegister(g);
  }
  function y() {
    e.startLogout();
  }
  function L() {
    e.manageAccount();
  }
  return r.shouldAutoFetchUserInfo && e.isLoggedIn === !0 && a(), r.shouldAutoRefresh && e.isLoggedIn === !0 && e.initAutoRefresh(), e.handlePostRedirect(r.onRedirect), {
    isLoggedIn: o,
    userInfo: n,
    getUserInfo: a,
    isGettingUserInfo: s,
    error: u,
    login: U,
    register: k,
    logout: y,
    manageAccount: L,
    refreshToken: A,
    initAutoRefresh: d
  };
}, X = {
  install(r, t) {
    let e;
    "instance" in t ? e = t.instance : (Q(t), e = J(t)), r.provide(P, e), Object.entries(D).forEach(([o, n]) => {
      r.component(o, n);
    });
  }
};
function Q(r) {
  if (!r.clientId)
    throw new Error("clientId is required");
  if (!r.serverUrl)
    throw new Error("serverUrl is required");
  if (!r.redirectUri)
    throw new Error("redirectUri is required");
}
export {
  H as FusionAuthAccountButton,
  b as FusionAuthLoginButton,
  C as FusionAuthLogoutButton,
  $ as FusionAuthRegisterButton,
  q as RequireAnonymous,
  V as RequireAuth,
  J as createFusionAuth,
  X as default,
  P as fusionAuthKey,
  h as useFusionAuth
};
//# sourceMappingURL=vue-fusionauth.js.map
